// EditBoxView.h : interface of the CEditBoxView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_EDITBOXVIEW_H__123D5389_F2DE_4BBB_A79D_FB2FCFB2BCF6__INCLUDED_)
#define AFX_EDITBOXVIEW_H__123D5389_F2DE_4BBB_A79D_FB2FCFB2BCF6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define SCREEN_WIDTH 256
#define SCREEN_HEIGHT 192
#define ENG_FONT_WIDTH 6
#define HAN_FONT_WIDTH 12
#define FONT_HEIGHT 12
#define MAX_DATA_LENGTH ( 1 * 1024 )

class CEditBoxView : public CView
{
protected:
	CFont m_clFont;
	char* m_pcBuffer;
	int m_iCurLine;
	BOOL m_bLButtonDown;
	CPoint m_clPoint;
	CPen m_clPen;

	//  ʿ κе
protected:
	//  Charactor µǴ ġ
	int m_iCurCharX;
	int m_iCurCharY;
	int m_iDataLength;
	//  Ŀ ġ
	int m_iCursorX;
	int m_iCursorY;
	//  ο ִ   ִ  
	int m_iMaxCharCountInLine;
	// ȭ鿡 ǥ  ִ ִ  
	int m_iMaxLineCount;


protected: // create from serialization only
	CEditBoxView();

	DECLARE_DYNCREATE(CEditBoxView)

// Attributes
public:
	CEditBoxDoc* GetDocument();

	// Ʒ   Լ
public:
	void MyPaint( CDC* pDC );
	void PrintData( CDC* pDC, char* pcData, int iCount );
	BOOL IsEnoughSpaceToPrint( int iToPrintCharCount );
	void MoveToNextLine( void );
	BOOL IsEnoughSpaceToNewLine( int iNewLineCount );
	BOOL FindLine( int iLineNumber, int* piStartPosition );
	BOOL GetCharCountInLine( int iLineIndex, int* piCharCount );
	BOOL IsCurCharYMatch( int iLineNubmer );
	void DrawCursor( CDC* pDC );
	BOOL MoveCursorRight( void );
	BOOL MoveCursorLeft( void );
	BOOL MoveCursorUp( void );
	BOOL MoveCursorDown( void );
	BOOL IsNewLine( char* pcBuffer );
	BOOL IsHangul( char* pcBuffer );
	BOOL AddString( int iColumn, int iLine, char* pcBuffer );
	BOOL AddCharactor( int iColumn, int iLine, char cData );
	BOOL DeleteCharactor( int iColumn, int iLine );
	BOOL ScrollDown( int iLineCount );
	BOOL ScrollUp( int iLineCount );

	BOOL IsValidRangeForCharX( int iX );
	BOOL IsValidRangeForCharY( int iy );

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEditBoxView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CEditBoxView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CEditBoxView)
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in EditBoxView.cpp
inline CEditBoxDoc* CEditBoxView::GetDocument()
   { return (CEditBoxDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EDITBOXVIEW_H__123D5389_F2DE_4BBB_A79D_FB2FCFB2BCF6__INCLUDED_)
